#include "StdAfx.h"
#include ".\nplocalfile.h"
#include <atlstr.h>
#include <atlpath.h>

CNPLocalFile::CNPLocalFile(void)
{
	m_hFile = INVALID_HANDLE_VALUE;
}
CNPLocalFile::~CNPLocalFile(void)
{
	Close();
}
BOOL CNPLocalFile::Open( LPCTSTR lpszURL, DWORD dwFlags /*= 0 */ )
{
	CString strURL = lpszURL;
	int nFindeIndex = strURL.Find(_T("file://"));
	if (nFindeIndex >= 0)
	{
		strURL = strURL.Right(strURL.GetLength()-nFindeIndex-_tcslen(_T("file://")));
		if (PathIsRelative(strURL))
		{
			TCHAR szModule[_MAX_PATH] = {0};
			::GetModuleFileName(NULL, szModule, _MAX_PATH);
			ATLPath::RemoveFileSpec(szModule);
			ATLPath::Append(szModule, strURL);
			strURL = szModule;
		}
	}
	m_hFile = CreateFile( strURL, dwFlags, FILE_SHARE_READ | FILE_SHARE_WRITE, 0, ( dwFlags == GENERIC_READ ) ? OPEN_EXISTING : OPEN_ALWAYS, 0, NULL );
	if ( m_hFile == INVALID_HANDLE_VALUE )
	{
		return FALSE;
	}
	return TRUE;
}
void CNPLocalFile::Close()
{
	if ( m_hFile != INVALID_HANDLE_VALUE )
	{
		CloseHandle( m_hFile );
		m_hFile = INVALID_HANDLE_VALUE;
	}
}
DWORD CNPLocalFile::Read( void* lpBuf, DWORD dwCount /*= 0 */ )
{
	if ( m_hFile == INVALID_HANDLE_VALUE )
	{
		return (DWORD)(-1);
	}
	DWORD dwRead;
	ReadFile( m_hFile, lpBuf, dwCount, &dwRead, NULL );
	return dwRead;
}
BOOL CNPLocalFile::Write( const void* lpBuf, DWORD dwCount )
{
	if ( m_hFile == INVALID_HANDLE_VALUE )
	{
		return -1;
	}
	DWORD dwWrite;
	WriteFile( m_hFile, lpBuf, dwCount, &dwWrite, NULL );
	return TRUE;
}
ULONGLONG CNPLocalFile::GetSize()
{
	if ( m_hFile == INVALID_HANDLE_VALUE )
	{
		return (ULONGLONG)(-1);
	}
	LARGE_INTEGER liFileSize;
	//ѿ GetFileSizeEx( m_hFile, &liFileSize );
	DWORD dwSizeLow = 0;
	DWORD dwSizeHigh = 0;
	dwSizeLow = GetFileSize (m_hFile, &dwSizeHigh);

	liFileSize.LowPart = dwSizeLow;
	liFileSize.HighPart = dwSizeHigh;
	liFileSize.QuadPart = dwSizeLow + dwSizeHigh;

	return liFileSize.QuadPart;
}

